# -*- coding:Utf-8 -*-
# quick_menu V1.126p (24/12/2008) by DoCky


import psyco, os.path, re, es, popuplib, gamethread, repeat
psyco.full()


class File:
    """
        Reader of text file (ex: '.cfg', '.txt', ...)
            * elimination of comments

                - basic
            syntax: File().read(<filepath>)
            return: ["line1", "line2", "ect..."]
            exemple: File.read(es.getAddonPath("myName") + "config.txt")

                - with separator
            syntax: File().read(<filepath>, <separator>)
            return: {"arg1" : "val1", "arg2" : "val2", "ect..."}
            exemple: File.read(es.getAddonPath("myName") + "config.txt", "=")
    """

    def __init__(self):
        self._line, self._sepa = [], {}

    def __loop(self, i, s):
        while i < len(self._line):
            self._line[i] = re.sub('//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\t)+|(\n)+|(")+|', "", self._line[i])
            if not self._line[i]: del(self._line[i])
            else:

                if s:
                    sepa = self._line[i].split(s)
                    if len(sepa) > 1:
                        self._sepa[sepa[0].strip()] = sepa[1].strip()
                        i += 1
                    else: del(self._line[i])
                else: i += 1

    def read(self, pathern = "", separator = ""):
        self._line, self._sepa = [], {}
        if not pathern:
            es.dbgmsg(0, "[quick_menu] syntax : File().read(<file pathern> [separator])")
            if separator: return self._sepa.copy()
            else: return self._line[:]

        else:
            try:
                line = open(pathern, "r")
                self._line = line.readlines()
                line.close(), self.__loop(0, separator)
            except:
                self._line, self._sepa = [], {}
                es.dbgmsg(0, "[quick_menu] Cannot read file : %s" % pathern)
            finally:
                if separator: return self._sepa.copy()
                else: return self._line[:]



class Menu:
    """
        Menu d'administration rapide
    """

    def __init__(self):
        """
            Initialisation et création des fonction du menu
        """

        self.m_time, self.m_list, self.m_user, self.m_maps, self.m_hook = Menu.Time(), Menu.List(), Menu.User(), Menu.Maps(), Menu.Hook()
        self._name, self._band, self._list, self._swap, self._kick, self._bans, self._remo, self._maps = set(), {}, {}, {}, {}, {}, {}, {}
        for menu in ("qm_recept",
                     "qm_action", "qm_action_swap", "qm_action_kick", "qm_action_bans", "qm_action_remo",
                     "qm_levels"): self._name.add(menu)

        m = popuplib.create("qm_recept")
        for line in ("Administration",
                     " ",
                     "->1. Option joueur",
                     "->2. Option map",
                     " ",
                     "0. Sortir"): m.addline(line)
        m.menuselect = self.__recept

        m = popuplib.create("qm_action")
        for line in ("Administration des joueurs",
                     " ",
                     "->1. Swaper",
                     "->2. Kicker",
                     "->3. Bannir",
                     "->4. Débannir",
                     " ", "9. Retour",
                     "0. Sortir"): m.addline(line)
        m.submenu(9, "qm_recept")
        m.menuselect = self.__action

        m = popuplib.create("qm_levels")
        for line in (
            "Changer de map",
            " ",
            "->1. Immédiatement",
            "->2. A la fin du round",
            "->3. A la fin du temps imparti",
            "->4. Rafraichir la liste des maps",
            " ",
            "9. Retour",
            "0. Sortir"
            ): m.addline(line)
        m.submenu(4, "qm_levels")
        m.submenu(9, "qm_recept")
        m.menuselect = self.__levels

    def __recept(self, i, c, n):
        if c == 1: popuplib.send("qm_action", i)
        elif c == 2: popuplib.send("qm_levels", i)


    def __action(self, i, c, n):
        if c == 1: self.m_list.menu("swap", "Swapper un joueur", es.getUseridList(), i)
        elif c == 2: self.m_list.menu("kick", "Kicker un joueur", es.getUseridList(), i)
        elif c == 3: self.m_list.menu("bans", "Bannir un joueur", es.getUseridList(), i)
        elif c == 4: self.m_list.menu("remo", "Débannir un joueur", None, i)

    def __levels(self, i, c, n):
        global _maps
        if c < 4:
            self._maps[i] = c
            self.m_list.menu("maps", "Changer de map", _maps, i)
        elif c == 4:
            _maps = [os.path.splitext(n)[0] for n in os.listdir("%s/maps/" % qm_path) if os.path.splitext(n)[1] == ".bsp"]
            es.tell(i, "#multi", "#green[quick_menu] #lightgreen #defaultla liste des maps a été actualisé")



    class Time():
        """
            Création d'un timer lorsqu'un joueur est banni
        """

        def __loop(self):
            """ """

        def init(self, n):
            repeat.create(n, self.__loop)

        def nume(self, n):
            time = repeat.find(n)["remaining"]
            seco = time % 60
            minu = time / 60
            hour = minu / 60

            if seco < 10: seco = "0%s" % seco
            if minu < 10: minu = "0%s" % minu
            if hour < 10: hour = "0%s" % hour
            return "%s:%s:%s" % (hour, minu, seco)



    class List():
        """
            Fonction :
                * création d'un menu selon une liste d'entitées
        """

        def __init__(self):
            self._list = {}

        def __page(self, n, m):
            if n < 2:page = 1
            else:
                page = n / m
                if n % m > 1:page += 1
            return page

        def __item(self, p, t, n, m):
            if p < t:item = m
            else:item = n - (p - 1) * m
            return item

        def menu(self, f, t, l, i):
            if f == "kick":
                if _menu._kick.has_key(i): del(_menu._kick[i])
            elif f == "bans":
                if _menu._bans.has_key(i): del(_menu._bans[i])
                es.server.cmd("writeid")
                perm = map(lambda x: x.split(" ")[2], File().read("%s/cfg/banned_user.cfg" % qm_path))
            elif f == "remo":
                if _menu._remo.has_key(i): del(_menu._remo[i])
                es.server.cmd("writeid")
                perm = map(lambda x: x.split(" ")[2], File().read("%s/cfg/banned_user.cfg" % qm_path))
                l = perm + _menu._band.keys()

            numb = len(l)
            page, indp = self.__page(numb, 7), 0

            while indp < page:
                indp += 1
                name, item, indi = "qm_%s_%s_%s" % (f, i, indp), self.__item(indp, page, numb, 7), 0

                _menu._name.add(name)
                self._list[name] = {}
                m = popuplib.create(name)
                m.addline("%s    %s/%s" % (t, indp, page))
                m.addline(" ")
                if f == "remo" and numb == 0: m.addline("* Auncun ban permanent")

                while indi < item:
                    indo = (indp - 1) * 7 + indi
                    indi += 1

                    if f == "swap":
                        user = es.getplayername(l[indo])
                        team = es.getplayerteam(l[indo])
                        self._list[name][indi] = (l[indo], team, user)

                        if team == 2: m.addline("->%s. [T] %s" % (indi, user))
                        elif team == 3: m.addline("->%s. [CT] %s" % (indi, user))
                        else: m.addline("->%s. [SPEC] %s" % (indi, user))

                    elif f == "kick":
                        user = es.getplayername(l[indo])
                        self._list[name][indi] = (l[indo], user)
                        m.addline("->%s. %s" % (indi, user))

                    elif f == "bans":
                        user = es.getplayername(l[indo])
                        unid = es.getplayersteamid(l[indo])
                        self._list[name][indi] = (l[indo], unid, user)

                        if unid in perm: m.addline("->%s. [B] %s" % (indi, user))
                        elif unid in _menu._band:
                            band = "qm_%s" % unid

                            if repeat.status(band) < 2:
                                del(_menu._band[unid])
                                m.addline("->%s. %s" % (indi, user))

                            else: m.addline("->%s. [%s] %s" % (indi, _menu.m_time.nume(band), user))
                        else:m.addline("->%s. %s" % (indi, user))

                    elif f == "remo":
                        if l[indo] in perm:
                            usid = es.getuserid(l[indo])
                            user = es.getplayername(usid)
                            self._list[name][indi] = (usid, l[indo], user)
                            if usid: m.addline("->%s. [B] %s" % (indi, es.getplayername(usid)))
                            else: m.addline("->%s. [B] %s" % (indi, l[indo]))

                        elif l[indo] in _menu._band:
                            usid = es.getuserid(l[indo])
                            user = es.getplayername(usid)
                            self._list[name][indi] = (usid, l[indo], user)
                            if usid: m.addline("->%s. [%s] %s" % (indi, _menu.m_time.nume("qm_%s" % l[indo]), user))
                            else: m.addline("->%s. [%s] %s" % (indi, _menu.m_time.nume("qm_%s" % l[indo]), _menu._band[l[indo]]))

                    elif f == "maps":
                        self._list[name][indi] = l[indo]
                        m.addline("->%s. %s" % (indi, l[indo]))

                m.addline(" ")
                if indp < page:
                    m.addline("8. Suivant")
                    m.submenu(8, "qm_%s_%s_%s" % (f, i, indp + 1))
                if indp == 1:
                    m.addline("9. Retour")
                    if f == "maps": m.submenu(9, "qm_levels")
                    else: m.submenu(9, "qm_action")
                else:
                    m.addline("9. Retour")
                    m.submenu(9, "qm_%s_%s_%s" % (f, i, indp - 1))

                if f == "swap": m.menuselect = _menu.m_user.swap
                elif f == "kick": m.menuselect = _menu.m_user.kick
                elif f == "bans": m.menuselect = _menu.m_user.bans
                elif f == "remo": m.menuselect = _menu.m_user.remo
                elif f == "maps": m.menuselect = _menu.m_maps.maps

                m.addline("0. Sortir")
            popuplib.send("qm_%s_%s_1" % (f, i), i)



    class User():
        """
            Fonction :
                * swaper
                * kicker
                * bannir
                * débannir
        """

        def __init__(self):
            m = popuplib.create("qm_action_swap")
            for line in ("Swaper un joueur",
                         " ",
                         " ",
                         " ",
                         " ",
                         "8. Changer",
                         "9. Retour",
                         "0. Sortir"): m.addline(line)
            m.submenu(9, "qm_action")
            m.menuselect = self.__swap

            m = popuplib.create("qm_action_kick")
            for line in ("Kicker un joueur",
                         " ",
                         " ",
                         " ",
                         "8. Changer",
                         "9. Retour",
                         "0. Sortir"): m.addline(line)
            m.submenu(9, "qm_action")
            m.menuselect = self.__kick

            m = popuplib.create("qm_action_bans")
            for line in ("Bannir un joueur",
                         " ",
                         "->1. 5 min",
                         "->2. 10 min",
                         "->3. 15 min",
                         "->4. 30 min",
                         "->5. 1 heure",
                         "->6. 2 heures",
                         "->7. Permanent",
                         " ",
                         "8. Changer",
                         "9. Retour",
                         "0. Sortir"): m.addline(line)
            m.submenu(9, "qm_action")
            m.menuselect = self.__bans

            m = popuplib.create("qm_action_remo")
            for line in ("Débannir un joueur",
                         " ",
                         " ",
                         " ",
                         "9. Retour",
                         "0. Sortir"): m.addline(line)
            m.submenu(9, "qm_action")
            m.menuselect = self.__remo


        def __swap(self, i, c, n):
            if c < 3:
                if not es.exists("userid", _menu._swap[i][0]): es.tell(i, "#multi", "#green[quick_menu]#default Impossible de trouver l'id : #lightgreen%s" % _menu._swap[i][0])
                else:
                    user = _menu._swap[i][0]
                    swap = _menu._swap[i][c]
                    team = es.getplayerteam(user)

                    if team == swap: es.tell(i, "#multi", "#green[war_menu] #lightgreen%s #defaultis allready in team selected" % _menu._swap[i][2])
                    else:
                        es.changeteam(user, 1)
                        if swap == 2: es.changeteam(user, swap)
                        elif swap == 3: es.changeteam(user, swap)

                gamethread.delayed(.075, _menu.m_list.menu("swap", "Swapper un joueur", es.getUseridList(), i))
            elif c == 8: gamethread.delayed(.075, _menu.m_list.menu("swap", "Swapper un joueur", es.getUseridList(), i))
            if _menu._swap.has_key(i): del(_menu._swap[i])

        def swap(self, i, c, n):
            if c in _menu.m_list._list[n]:
                m = popuplib.find("qm_action_swap")
                team = _menu.m_list._list[n][c][1]

                if team == 2:
                    _menu._swap[i] = (_menu.m_list._list[n][c][0], 3, 1, _menu.m_list._list[n][c][2])
                    m.modline(3, "->1. Anti-terroriste")
                    m.modline(4, "->2. Spectateur")

                elif team == 3:
                    _menu._swap[i] = (_menu.m_list._list[n][c][0], 2, 1, _menu.m_list._list[n][c][2])
                    m.modline(3, "->1. Terroriste")
                    m.modline(4, "->2. Spectateur")

                else:
                    _menu._swap[i] = (_menu.m_list._list[n][c][0], 3, 2, _menu.m_list._list[n][c][2])
                    m.modline(3, "->1. Anti-terroriste")
                    m.modline(4, "->2. Terroriste")
                m.send(i)


        def __kick(self, i, c, n):
            if c == 1 and _menu._kick.has_key(i):
                if not es.exists("userid", _menu._kick[i][0]): es.tell(i, "#multi", "#green[quick_menu]#default Impossible de trouver l'id : #lightgreen%s" % _menu._kick[i][0])
                else: es.server.queuecmd("kickid %s" % _menu._kick[i][0])

                gamethread.delayed(.075, _menu.m_list.menu("kick", "Kicker un joueur", es.getUseridList(), i))
            elif c == 8: gamethread.delayed(.075, _menu.m_list.menu("kick", "Kicker un joueur", es.getUseridList(), i))
            if _menu._kick.has_key(i): del(_menu._kick[i])
            _menu.m_hook.chat()

        def kick(self, i, c, n):
            if c in _menu.m_list._list[n]:
                _menu._kick[i] = _menu.m_list._list[n][c]
                _menu.m_hook.chat()
                es.tell(i, "#multi", "#green[quick_menu]#default Tu peux écrire la raison du kick dans le chat")

                m = popuplib.find("qm_action_kick")
                m.modline(3, "->1. Kick immédiat : %s" % _menu.m_list._list[n][c][1])
                m.send(i)


        def __bans(self, i, c, n):
            if c < 8:
                _menu._band[_menu._bans[i][1]] = _menu._bans[i][2]
                name = "qm_%s" % _menu._bans[i][1]
                _menu.m_time.init(name)

                if c == 1:
                    es.server.queuecmd("banid 1 %s;kickid %s ban 5m" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 300)
                elif c == 2:
                    es.server.queuecmd("banid 10 %s;kickid %s ban 10m" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 600)
                elif c == 3:
                    es.server.queuecmd("banid 15 %s;kickid %s ban 15m" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 900)
                elif c == 4:
                    es.server.queuecmd("banid 30 %s;kickid %s ban 30m" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 1800)
                elif c == 5:
                    es.server.queuecmd("banid 60 %s;kickid %s ban 1h" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 3600)
                elif c == 6:
                    es.server.queuecmd("banid 120 %s;kickid %s ban 2h" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.start(name, 1, 7200)
                elif c == 7:
                    es.server.queuecmd("banid 0 %s;kickid %s ban permanent" % (_menu._bans[i][1], _menu._bans[i][1]))
                    repeat.delete(name)
                if _menu._bans.has_key(i): del(_menu._bans[i])

                gamethread.delayed(.075, _menu.m_list.menu, ("bans", "Bannir un joueur", es.getUseridList(), i))
            elif c == 8: gamethread.delayed(.075, _menu.m_list.menu, ("bans", "Bannir un joueur", es.getUseridList(), i))
            _menu.m_hook.chat()

        def bans(self, i, c, n):
            if c in _menu.m_list._list[n]:
                _menu._bans[i] = _menu.m_list._list[n][c]
                _menu.m_hook.chat()
                es.tell(i, "#multi", "#green[quick_menu]#default Tu peux écrire le temps et la raison du ban dans le chat")
                popuplib.send("qm_action_bans", i)


        def remo(self, i, c, n):
            if c in _menu.m_list._list[n]:
                _menu._remo[i] = _menu.m_list._list[n][c]
                _menu.m_hook.chat()
                es.tell(i, "#multi", "#green[quick_menu]#default Tu peux écrire le steamid du joueur a débannir dans le chat")

                m = popuplib.find("qm_action_remo")
                m.modline(3, "->1. Débannir immédiatemment : %s" % _menu.m_list._list[n][c][2])
                m.send(i)

        def __remo(self, i, c, n):
            if c == 1:
                es.server.queuecmd("removeid %s" % _menu._remo[i][1])
                gamethread.delayed(.075, _menu.m_list.menu, ("remo", "Déannir un joueur", None, i))
                if _menu._remo[i][1] in _menu._band: del(_menu._band[_menu._remo[i][1]])
            elif c == 8: gamethread.delayed(.075, _menu.m_list.menu, ("remo", "Déannir un joueur", None, i))
            _menu.m_hook.chat()



    class Maps:
        """
            Get Map list
        """

        def maps(self, i, c, n):
            if c in _menu.m_list._list[n]:
                mode = _menu._maps[i]
                name = _menu.m_list._list[n][c]

                if mode == 1:
                    es.forcevalue("eventscripts_nextmapoverride", "")
                    es.server.queuecmd("changelevel %s" % name)
                elif mode == 2:
                    es.forcevalue("eventscripts_nextmapoverride", "")
                    es.forcevalue("nextlevel", name)
                elif mode == 3: es.forcevalue("eventscripts_nextmapoverride", name)



    class Hook:
        """
            Get players arguments by chat
                * kick
                * ban
        """

        def __hook(self, i, t, o):
            if _menu._kick.has_key(i):
                es.server.queuecmd("kickid %s %s" % (_menu._kick[i][0], t.replace('"', "")))
                del(_menu._kick[i])
                self.chat()
                if popuplib.isqueued("qm_action_kick", i): popuplib.unsendname("qm_action_kick", i)
                gamethread.delayed(.075, _menu.m_list.menu, ("kick", "Kicker un joueur", es.getUseridList(), i))
                i = 0

            elif _menu._bans.has_key(i):
                text = t.replace('"', "").split(" ")
                time = text[0]
                del(text[0])

                if not time.isdigit(): es.tell(i, "#multi", "#green[quick_menu]#default syntax : <temps> [message]")
                else:
                    es.server.queuecmd("banid %s %s;kickid %s %s;writeid" % (time, _menu._bans[i][0], _menu._bans[i][0], " ".join(text)))
                    if int(time):
                        name = "qm_%s" % _menu._bans[i][1]
                        _menu._band[_menu._bans[i][1]] = _menu._bans[i][2]
                        _menu.m_time.init(name)
                        repeat.start(name, 1, float(time) * 60)

                    del(_menu._bans[i])
                    self.chat()
                    if popuplib.isqueued("qm_action_bans", i): popuplib.unsendname("qm_action_bans", i)
                    gamethread.delayed(.075, _menu.m_list.menu, ("bans", "Bannir un joueur", es.getUseridList(), i))
                    i = 0

            elif _menu._remo.has_key(i):
                unid = t.replace('"', "").strip().split(" ")
                unid = unid[0]
                unid.upper()

                if not "STEAM_" in unid: es.tell(i, "#multi", "#green[quick_menu]#default syntax : <STEAMID>")
                else:
                    es.server.queuecmd("removeid %s" % unid)

                    del(_menu._remo[i])
                    self.chat()
                    if popuplib.isqueued("qm_action_remo", i): popuplib.unsendname("qm_action_remo", i)
                    gamethread.delayed(.075, _menu.m_list.menu, ("remo", "Débannir un joueur", None, i))
                    i = 0

            return i, t, o

        def __send(self, i, m):
            if es.exists("userid", i):
                if m == "kick" and popuplib.isqueued("qm_kick", user): popuplib.unsendname("qm_kick", user)
                elif m == "bans" and popuplib.isqueued("qm_bans", user): popuplib.unsendname("qm_bans", user)
                _menu._user.list(m, i)

        def chat(self):
            if len(_menu._kick) or len(_menu._bans) or len(_menu._remo) and not self.__hook in es.addons.SayListeners:
                es.addons.registerSayFilter(self.__hook)
                es.dbgmsg(0, "[quick_menu] Chat is now hooked")
            else: self.stop()

        def stop(self):
            if self.__hook in es.addons.SayListeners:
                es.addons.unregisterSayFilter(self.__hook)
                es.dbgmsg(0, "[quick_menu] Chat is now unhooked")




qm_info = es.AddonInfo()
qm_info.author = "DoCky"
qm_info.name = "quick_menu"
qm_info.version = "1.126p"
qm_info.url = "http://addons.eventscripts.com/addons/user/11751"
qm_path = es.ServerVar("eventscripts_gamedir")
qm_vers = es.ServerVar(qm_info.name, "", "By DoCky -")
qm_vers.set(qm_info.version)
qm_vers.makepublic()


def init():
    global _menu, _user, _maps
    _menu, _user, _maps = Menu(), File().read("%s/cfg/quick_menu/adminlist.cfg" % qm_path), [os.path.splitext(n)[0] for n in os.listdir("%s/maps/" % qm_path) if os.path.splitext(n)[1] == ".bsp"]
    if not len(_user): es.dbgmsg(0, "[quick_menu] Can't load admin list")
    else: es.dbgmsg(0, "[quick_menu] Has been loaded successfully")

def player_cmd():
    user = es.getcmduserid()
    if es.getplayersteamid(user) in _user:
        name = popuplib.active(user)['name']
        if name != "0": popuplib.close(name, user)
        popuplib.send("qm_recept", user)

def unload():
    _menu.m_hook.stop()
    es.unregsaycmd("!qm")
    es.unregclientcmd("!qm")
    for menu in _menu._name: popuplib.delete(menu)
    for time in _menu._band: repeat.delete("qm_%s" % time)
    es.dbgmsg(0, "[quick_menu] Has been unloaded successfully")

def load():
    es.regsaycmd("!qm", "quick_menu/player_cmd", "command for acces quick menu")
    es.regclientcmd("!qm", "quick_menu/player_cmd", "command for acces quick menu")
    init()

def es_map_start(e):
    for menu in _menu._name: popuplib.delete(menu)
    for time in _menu._band: repeat.delete("qm_%s" % time)
    _menu.m_hook.stop()
    init()

def player_disconnect(e):
    if e["networkid"] in _user:
        user = int(e["userid"])
        if _menu._kick.has_key(user): del(_menu._kick[user])
        if _menu._bans.has_key(user): del(_menu._bans[user])
        if _menu._remo.has_key(user): del(_menu._remo[user])
        _menu.m_hook.chat()
